diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.38/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.37/src/wifi/model/ht/ht-frame-exchange-manager.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/ht/ht-frame-exchange-manager.cc	2023-03-16 20:54:23.856869200 -0700
@@ -1265,13 +1422,15 @@
             // if a BA agreement exists, we can get here if there is no outstanding
             // MPDU whose lifetime has not expired yet.
             GetWifiRemoteStationManager()->ReportFinalDataFailed(*psdu->begin());
-            if (GetBaManager(tid)->ExistsAgreementInState(recipient,
-                                                          tid,
-                                                          OriginatorBlockAckAgreement::ESTABLISHED))
+            if (isBar)
+            {
+                DequeuePsdu(psdu);
+            }
+            if (m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid))
             {
-                // schedule a BlockAckRequest with skipIfNoDataQueued set to true, so that the
-                // BlockAckRequest is only sent if there are data frames queued for this recipient.
-                edca->ScheduleBar(edca->PrepareBlockAckRequest(recipient, tid), true);
+                // schedule a BlockAckRequest to be sent only if there are data frames queued
+                // for this recipient
+                GetBaManager(tid)->AddToSendBarIfDataQueuedList(recipientMld, tid);
             }
             resetCw = true;
         }
@@ -1293,7 +1452,7 @@
         else
         {
             NS_LOG_DEBUG("Missed Block Ack, retransmit data frames");
-            GetBaManager(tid)->NotifyMissedBlockAck(recipient, tid);
+            GetBaManager(tid)->NotifyMissedBlockAck(m_linkId, recipientMld, tid);
             resetCw = false;
         }
     }
@@ -1309,7 +1468,12 @@
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_CTL_BACKRESP);
-    hdr.SetAddr1(agreement.GetPeer());
+    auto addr1 = agreement.GetPeer();
+    if (auto originator = GetWifiRemoteStationManager()->GetAffiliatedStaAddress(addr1))
+    {
+        addr1 = *originator;
+    }
+    hdr.SetAddr1(addr1);
     hdr.SetAddr2(m_self);
     hdr.SetDsNotFrom();
     hdr.SetDsNotTo();
@@ -1345,20 +1509,6 @@
     ForwardPsduDown(psdu, blockAckTxVector);
 }
 
-bool
-HtFrameExchangeManager::GetBaAgreementEstablished(Mac48Address originator, uint8_t tid) const
-{
-    return (m_agreements.find({originator, tid}) != m_agreements.end());
-}
-
-BlockAckType
-HtFrameExchangeManager::GetBlockAckType(Mac48Address originator, uint8_t tid) const
-{
-    auto it = m_agreements.find({originator, tid});
-    NS_ABORT_MSG_IF(it == m_agreements.end(), "No established Block Ack agreement");
-    return it->second.GetBlockAckType();
-}
-
 void
 HtFrameExchangeManager::ReceiveMpdu(Ptr<const WifiMpdu> mpdu,
                                     RxSignalInfo rxSignalInfo,
@@ -1408,8 +1558,11 @@
             mpdu->GetPacket()->PeekHeader(blockAck);
             uint8_t tid = blockAck.GetTidInfo();
             std::pair<uint16_t, uint16_t> ret =
-                GetBaManager(tid)->NotifyGotBlockAck(blockAck, hdr.GetAddr2(), {tid});
-            GetWifiRemoteStationManager()->ReportAmpduTxStatus(hdr.GetAddr2(),
+                GetBaManager(tid)->NotifyGotBlockAck(m_linkId,
+                                                     blockAck,
+                                                     m_mac->GetMldAddress(sender).value_or(sender),
+                                                     {tid});
+            GetWifiRemoteStationManager()->ReportAmpduTxStatus(sender,
                                                                ret.first,
                                                                ret.second,
                                                                rxSnr,
@@ -1423,6 +1576,11 @@
             // Reset the CW
             m_edca->ResetCw(m_linkId);
 
+            // if this BlockAck was sent in response to a BlockAckReq, dequeue the blockAckReq
+            if (m_psdu && m_psdu->GetNMpdus() == 1 && m_psdu->GetHeader(0).IsBlockAckReq())
+            {
+                DequeuePsdu(m_psdu);
+            }
             m_psdu = nullptr;
             TransmissionSucceeded();
         }
@@ -1439,22 +1597,25 @@
             NS_ABORT_MSG_IF(blockAckReq.IsMultiTid(), "Multi-TID BlockAckReq not supported");
             uint8_t tid = blockAckReq.GetTidInfo();
 
-            auto agreementIt = m_agreements.find({sender, tid});
+            auto agreement = m_mac->GetBaAgreementEstablishedAsRecipient(sender, tid);
 
-            if (agreementIt == m_agreements.end())
+            if (!agreement)
             {
                 NS_LOG_DEBUG("There's not a valid agreement for this BlockAckReq");
                 return;
             }
 
-            agreementIt->second.NotifyReceivedBar(blockAckReq.GetStartingSequence());
+            GetBaManager(tid)->NotifyGotBlockAckRequest(
+                m_mac->GetMldAddress(sender).value_or(sender),
+                tid,
+                blockAckReq.GetStartingSequence());
 
             NS_LOG_DEBUG("Schedule Block Ack");
             Simulator::Schedule(
                 m_phy->GetSifs(),
                 &HtFrameExchangeManager::SendBlockAck,
                 this,
-                agreementIt->second,
+                *agreement,
                 hdr.GetDuration(),
                 GetWifiRemoteStationManager()->GetBlockAckTxVector(sender, txVector),
                 rxSnr);
@@ -1471,13 +1632,12 @@
     {
         uint8_t tid = hdr.GetQosTid();
 
-        auto agreementIt = m_agreements.find({hdr.GetAddr2(), tid});
-        if (agreementIt != m_agreements.end())
+        if (m_mac->GetBaAgreementEstablishedAsRecipient(hdr.GetAddr2(), tid))
         {
             // a Block Ack agreement has been established
             NS_LOG_DEBUG("Received from=" << hdr.GetAddr2() << " (" << *mpdu << ")");
 
-            agreementIt->second.NotifyReceivedMpdu(mpdu);
+            GetBaManager(tid)->NotifyGotMpdu(mpdu);
 
             if (!inAmpdu && hdr.GetQosAckPolicy() == WifiMacHeader::NORMAL_ACK)
             {
@@ -1517,14 +1677,14 @@
         {
             // Normal Ack or Implicit Block Ack Request
             NS_LOG_DEBUG("Schedule Block Ack");
-            auto agreementIt = m_agreements.find({psdu->GetAddr2(), tid});
-            NS_ASSERT(agreementIt != m_agreements.end());
+            auto agreement = m_mac->GetBaAgreementEstablishedAsRecipient(psdu->GetAddr2(), tid);
+            NS_ASSERT(agreement);
 
             Simulator::Schedule(
                 m_phy->GetSifs(),
                 &HtFrameExchangeManager::SendBlockAck,
                 this,
-                agreementIt->second,
+                *agreement,
                 psdu->GetDuration(),
                 GetWifiRemoteStationManager()->GetBlockAckTxVector(psdu->GetAddr2(), txVector),
                 rxSignalInfo.snr);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ht/ht-frame-exchange-manager.h ns-3.38/src/wifi/model/ht/ht-frame-exchange-manager.h
--- ns-3.37/src/wifi/model/ht/ht-frame-exchange-manager.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/ht/ht-frame-exchange-manager.h	2023-03-16 20:54:23.856869200 -0700
@@ -141,31 +141,6 @@
                                                Time ppduDurationLimit) const;
 
     /**
-     * \param respHdr Add block ack response from originator (action
-     *        frame).
-     * \param originator Address of peer station involved in block ack
-     *        mechanism.
-     * \param startingSeq Sequence number of the first MPDU of all
-     *        packets for which block ack was negotiated.
-     *
-     * This function is typically invoked only by ns3::WifiMac
-     * when the STA (which may be non-AP in ESS, or in an IBSS) has
-     * received an ADDBA Request frame and is transmitting an ADDBA
-     * Response frame. At this point the frame exchange manager must
-     * allocate buffers to collect all correctly received packets belonging
-     * to the category for which block ack was negotiated.
-     */
-    void CreateBlockAckAgreement(const MgtAddBaResponseHeader* respHdr,
-                                 Mac48Address originator,
-                                 uint16_t startingSeq);
-    /**
-     * Destroy a Block Ack agreement.
-     *
-     * \param originator the originator MAC address
-     * \param tid the TID associated with the Block Ack agreement
-     */
-    void DestroyBlockAckAgreement(Mac48Address originator, uint8_t tid);
-    /**
      * This method can be called to accept a received ADDBA Request. An
      * ADDBA Response will be constructed and queued for transmission.
      *
@@ -182,26 +157,6 @@
     virtual uint16_t GetSupportedBaBufferSize() const;
 
     /**
-     * Return true if a Block Ack agreement has been established with the given
-     * originator for the given TID.
-     *
-     * \param originator the MAC address of the given originator
-     * \param tid the Traffic ID
-     * \return true if a Block Ack agreement has been established with the given
-     *         originator for the given TID
-     */
-    bool GetBaAgreementEstablished(Mac48Address originator, uint8_t tid) const;
-
-    /**
-     * Get the type of BlockAck frames sent to the given originator.
-     *
-     * \param originator the MAC address of the given originator
-     * \param tid the Traffic ID
-     * \return the type of BlockAck frames sent to the given originator
-     */
-    BlockAckType GetBlockAckType(Mac48Address originator, uint8_t tid) const;
-
-    /**
      * Sends DELBA frame to cancel a block ack agreement with STA
      * addressed by <i>addr</i> for TID <i>tid</i>.
      *
@@ -211,6 +166,21 @@
      */
     void SendDelbaFrame(Mac48Address addr, uint8_t tid, bool byOriginator);
 
+    /**
+     * Get the next BlockAckRequest or MU-BAR Trigger Frame to send, if any. If TID and recipient
+     * address are given, then only return a BlockAckRequest, if any, addressed to that recipient
+     * and for the given TID.
+     *
+     * \param ac the AC whose queue is searched for BlockAckRequest or Trigger Frames
+     * \param optTid the TID (optional)
+     * \param optAddress the recipient of the BAR (optional)
+     *
+     * \return the next BAR or Trigger Frame to be sent, if any
+     */
+    Ptr<WifiMpdu> GetBar(AcIndex ac,
+                         std::optional<uint8_t> optTid = std::nullopt,
+                         std::optional<Mac48Address> optAddress = std::nullopt);
+
   protected:
     void DoDispose() override;
 
@@ -225,7 +195,7 @@
     void NotifyReceivedNormalAck(Ptr<WifiMpdu> mpdu) override;
     void NotifyPacketDiscarded(Ptr<const WifiMpdu> mpdu) override;
     void RetransmitMpduAfterMissedAck(Ptr<WifiMpdu> mpdu) const override;
-    void ReleaseSequenceNumber(Ptr<WifiMpdu> mpdu) const override;
+    void ReleaseSequenceNumbers(Ptr<const WifiPsdu> psdu) const override;
     void ForwardMpduDown(Ptr<WifiMpdu> mpdu, WifiTxVector& txVector) override;
     void CtsTimeout(Ptr<WifiMpdu> rts, const WifiTxVector& txVector) override;
     void TransmissionSucceeded() override;
@@ -292,12 +262,11 @@
     void DequeuePsdu(Ptr<const WifiPsdu> psdu);
 
     /**
-     * If the Block Ack Manager associated with the given EDCA has a BlockAckReq frame
-     * to transmit (the duration of which plus the response fits within the given
-     * available time, if the latter is not Time::Min() and this is not the initial
-     * frame of a TXOP), transmit the frame and return true. Otherwise, return false.
+     * If the given MPDU contains a BlockAckReq frame (the duration of which plus the response
+     * fits within the given available time, if the latter is not Time::Min() and this is not
+     * the initial frame of a TXOP), transmit the frame and return true. Otherwise, return false.
      *
-     * \param edca the EDCAF which has been granted the opportunity to transmit
+     * \param mpdu the given MPDU
      * \param availableTime the amount of time allowed for the frame exchange. Equals
      *                      Time::Min() in case the TXOP limit is null
      * \param initialFrame true if the frame being transmitted is the initial frame
@@ -305,7 +274,7 @@
      *                     limit can be exceeded
      * \return true if frame is transmitted, false otherwise
      */
-    virtual bool SendMpduFromBaManager(Ptr<QosTxop> edca, Time availableTime, bool initialFrame);
+    virtual bool SendMpduFromBaManager(Ptr<WifiMpdu> mpdu, Time availableTime, bool initialFrame);
 
     /**
      * Given a non-broadcast QoS data frame, prepare the PSDU to transmit by attempting
@@ -387,14 +356,8 @@
     /// agreement key typedef (MAC address and TID)
     typedef std::pair<Mac48Address, uint8_t> AgreementKey;
 
-    /// typedef for map of recipient Block Ack agreements
-    using RecipientBlockAckAgreementMap = std::map<AgreementKey, RecipientBlockAckAgreement>;
-
-    RecipientBlockAckAgreementMap m_agreements;        //!< Block Ack agreements
-    RecipientBlockAckAgreementMap m_pendingAgreements; //!< pending Block Ack agreements (waiting
-                                                       //!< for Ack in response to ADDBA_RESPONSE)
-    Ptr<MsduAggregator> m_msduAggregator;              //!< A-MSDU aggregator
-    Ptr<MpduAggregator> m_mpduAggregator;              //!< A-MPDU aggregator
+    Ptr<MsduAggregator> m_msduAggregator; //!< A-MSDU aggregator
+    Ptr<MpduAggregator> m_mpduAggregator; //!< A-MPDU aggregator
 
     /// pending ADDBA_RESPONSE frames indexed by agreement key
     std::map<AgreementKey, Ptr<WifiMpdu>> m_pendingAddBaResp;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ht/ht-phy.cc ns-3.38/src/wifi/model/ht/ht-phy.cc
--- ns-3.37/src/wifi/model/ht/ht-phy.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/ht/ht-phy.cc	2023-03-16 20:54:23.856869200 -0700
@@ -459,10 +459,9 @@
 }
 
 Ptr<SpectrumValue>
-HtPhy::GetTxPowerSpectralDensity(double txPowerW,
-                                 Ptr<const WifiPpdu> /* ppdu */,
-                                 const WifiTxVector& txVector) const
+HtPhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
 {
+    const auto& txVector = ppdu->GetTxVector();
     uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
     uint16_t channelWidth = txVector.GetChannelWidth();
     NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ht/ht-phy.h ns-3.38/src/wifi/model/ht/ht-phy.h
--- ns-3.37/src/wifi/model/ht/ht-phy.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/ht/ht-phy.h	2023-03-16 20:54:23.856869200 -0700
@@ -464,8 +464,7 @@
     bool IsAllConfigSupported(WifiPpduField field, Ptr<const WifiPpdu> ppdu) const override;
     bool IsConfigSupported(Ptr<const WifiPpdu> ppdu) const override;
     Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
-                                                 Ptr<const WifiPpdu> ppdu,
-                                                 const WifiTxVector& txVector) const override;
+                                                 Ptr<const WifiPpdu> ppdu) const override;
     uint32_t GetMaxPsduSize() const override;
     CcaIndication GetCcaIndication(const Ptr<const WifiPpdu> ppdu) override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ht/ht-ppdu.cc ns-3.38/src/wifi/model/ht/ht-ppdu.cc
--- ns-3.37/src/wifi/model/ht/ht-ppdu.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/ht/ht-ppdu.cc	2023-03-16 20:54:23.860869400 -0700
@@ -47,6 +47,32 @@
                false) // don't instantiate LSigHeader of OfdmPpdu
 {
     NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << ppduDuration << band << uid);
+    SetPhyHeaders(txVector, ppduDuration, psdu->GetSize());
+}
+
+void
+HtPpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration, std::size_t psduSize)
+{
+    NS_LOG_FUNCTION(this << txVector << ppduDuration << psduSize);
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader lSig;
+    SetLSigHeader(lSig, ppduDuration);
+
+    HtSigHeader htSig;
+    SetHtSigHeader(htSig, txVector, psduSize);
+
+    m_phyHeaders->AddHeader(htSig);
+    m_phyHeaders->AddHeader(lSig);
+#else
+    SetLSigHeader(m_lSig, ppduDuration);
+    SetHtSigHeader(m_htSig, txVector, psduSize);
+#endif
+}
+
+void
+HtPpdu::SetLSigHeader(LSigHeader& lSig, Time ppduDuration) const
+{
     uint8_t sigExtension = 0;
     if (m_band == WIFI_PHY_BAND_2_4GHZ)
     {
@@ -58,16 +84,17 @@
                              4.0) *
                         3) -
                        3);
-    m_lSig.SetLength(length);
-    m_htSig.SetMcs(txVector.GetMode().GetMcsValue());
-    m_htSig.SetChannelWidth(m_channelWidth);
-    m_htSig.SetHtLength(psdu->GetSize());
-    m_htSig.SetAggregation(txVector.IsAggregation());
-    m_htSig.SetShortGuardInterval(txVector.GetGuardInterval() == 400);
+    lSig.SetLength(length);
 }
 
-HtPpdu::~HtPpdu()
+void
+HtPpdu::SetHtSigHeader(HtSigHeader& htSig, const WifiTxVector& txVector, std::size_t psduSize) const
 {
+    htSig.SetMcs(txVector.GetMode().GetMcsValue());
+    htSig.SetChannelWidth(txVector.GetChannelWidth());
+    htSig.SetHtLength(psduSize);
+    htSig.SetAggregation(txVector.IsAggregation());
+    htSig.SetShortGuardInterval(txVector.GetGuardInterval() == 400);
 }
 
 WifiTxVector
@@ -75,27 +102,70 @@
 {
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
-    txVector.SetMode(HtPhy::GetHtMcs(m_htSig.GetMcs()));
-    txVector.SetChannelWidth(m_htSig.GetChannelWidth());
-    txVector.SetNss(1 + (m_htSig.GetMcs() / 8));
-    txVector.SetGuardInterval(m_htSig.GetShortGuardInterval() ? 400 : 800);
-    txVector.SetAggregation(m_htSig.GetAggregation());
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    auto phyHeaders = m_phyHeaders->Copy();
+
+    LSigHeader lSig;
+    if (phyHeaders->RemoveHeader(lSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing L-SIG header in HT PPDU");
+    }
+
+    HtSigHeader htSig;
+    if (phyHeaders->RemoveHeader(htSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing HT-SIG header in HT PPDU");
+    }
+
+    SetTxVectorFromPhyHeaders(txVector, lSig, htSig);
+#else
+    SetTxVectorFromPhyHeaders(txVector, m_lSig, m_htSig);
+#endif
+
     return txVector;
 }
 
+void
+HtPpdu::SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                  const LSigHeader& lSig,
+                                  const HtSigHeader& htSig) const
+{
+    txVector.SetMode(HtPhy::GetHtMcs(htSig.GetMcs()));
+    txVector.SetChannelWidth(htSig.GetChannelWidth());
+    txVector.SetNss(1 + (htSig.GetMcs() / 8));
+    txVector.SetGuardInterval(htSig.GetShortGuardInterval() ? 400 : 800);
+    txVector.SetAggregation(htSig.GetAggregation());
+}
+
 Time
 HtPpdu::GetTxDuration() const
 {
     Time ppduDuration = Seconds(0);
     const WifiTxVector& txVector = GetTxVector();
-    ppduDuration = WifiPhy::CalculateTxDuration(m_htSig.GetHtLength(), txVector, m_band);
+
+    uint16_t htLength = 0;
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    auto phyHeaders = m_phyHeaders->Copy();
+
+    LSigHeader lSig;
+    phyHeaders->RemoveHeader(lSig);
+    HtSigHeader htSig;
+    phyHeaders->RemoveHeader(htSig);
+
+    htLength = htSig.GetHtLength();
+#else
+    htLength = m_htSig.GetHtLength();
+#endif
+
+    ppduDuration = WifiPhy::CalculateTxDuration(htLength, txVector, m_band);
     return ppduDuration;
 }
 
 Ptr<WifiPpdu>
 HtPpdu::Copy() const
 {
-    return Create<HtPpdu>(GetPsdu(), GetTxVector(), m_txCenterFreq, GetTxDuration(), m_band, m_uid);
+    return Ptr<WifiPpdu>(new HtPpdu(*this), false);
 }
 
 HtPpdu::HtSigHeader::HtSigHeader()
@@ -107,10 +177,6 @@
 {
 }
 
-HtPpdu::HtSigHeader::~HtSigHeader()
-{
-}
-
 TypeId
 HtPpdu::HtSigHeader::GetTypeId()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ht/ht-ppdu.h ns-3.38/src/wifi/model/ht/ht-ppdu.h
--- ns-3.37/src/wifi/model/ht/ht-ppdu.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/ht/ht-ppdu.h	2023-03-16 20:54:23.860869400 -0700
@@ -52,7 +52,6 @@
     {
       public:
         HtSigHeader();
-        ~HtSigHeader() override;
 
         /**
          * \brief Get the type ID.
@@ -151,10 +150,6 @@
            Time ppduDuration,
            WifiPhyBand band,
            uint64_t uid);
-    /**
-     * Destructor for HtPpdu.
-     */
-    ~HtPpdu() override;
 
     Time GetTxDuration() const override;
     Ptr<WifiPpdu> Copy() const override;
@@ -162,8 +157,49 @@
   private:
     WifiTxVector DoGetTxVector() const override;
 
+    /**
+     * Fill in the PHY headers.
+     *
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param ppduDuration the transmission duration of this PPDU
+     * \param psduSize the size duration of the PHY payload (PSDU)
+     */
+    void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration, std::size_t psduSize);
+
+    /**
+     * Fill in the L-SIG header.
+     *
+     * \param lSig the L-SIG header to fill in
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    virtual void SetLSigHeader(LSigHeader& lSig, Time ppduDuration) const;
+
+    /**
+     * Fill in the HT-SIG header.
+     *
+     * \param htSig the HT-SIG header to fill in
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param psduSize the size duration of the PHY payload (PSDU)
+     */
+    void SetHtSigHeader(HtSigHeader& htSig,
+                        const WifiTxVector& txVector,
+                        std::size_t psduSize) const;
+
+    /**
+     * Fill in the TXVECTOR from PHY headers.
+     *
+     * \param txVector the TXVECTOR to fill in
+     * \param lSig the L-SIG header
+     * \param htSig the HT-SIG header
+     */
+    void SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                   const LSigHeader& lSig,
+                                   const HtSigHeader& htSig) const;
+
+#ifndef NS3_BUILD_PROFILE_DEBUG
     HtSigHeader m_htSig; //!< the HT-SIG PHY header
-};                       // class HtPpdu
+#endif
+}; // class HtPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/interference-helper.cc ns-3.38/src/wifi/model/interference-helper.cc
--- ns-3.37/src/wifi/model/interference-helper.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/interference-helper.cc	2023-03-16 20:54:23.860869400 -0700
@@ -88,7 +88,7 @@
 double
 Event::GetRxPowerW() const
 {
-    NS_ASSERT(m_rxPowerW.size() > 0);
+    NS_ASSERT(!m_rxPowerW.empty());
     // The total RX power corresponds to the maximum over all the bands
     auto it = std::max_element(
         m_rxPowerW.begin(),
@@ -628,7 +628,7 @@
     }
 
     double psr = 1.0;
-    if (!sections.empty() > 0)
+    if (!sections.empty())
     {
         psr = CalculatePhyHeaderSectionPsr(event, nis, channelWidth, band, sections);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/mac-rx-middle.cc ns-3.38/src/wifi/model/mac-rx-middle.cc
--- ns-3.37/src/wifi/model/mac-rx-middle.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/mac-rx-middle.cc	2023-03-16 20:54:23.860869400 -0700
@@ -301,7 +301,8 @@
 MacRxMiddle::Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId)
 {
     NS_LOG_FUNCTION(*mpdu << +linkId);
-    const WifiMacHeader* hdr = &mpdu->GetHeader();
+    // consider the MAC header of the original MPDU (makes a difference for data frames only)
+    const WifiMacHeader* hdr = &mpdu->GetOriginal()->GetHeader();
     NS_ASSERT(hdr->IsData() || hdr->IsMgt());
 
     OriginatorRxStatus* originator = Lookup(hdr);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/mgt-headers.cc ns-3.38/src/wifi/model/mgt-headers.cc
--- ns-3.37/src/wifi/model/mgt-headers.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/mgt-headers.cc	2023-03-16 20:54:23.860869400 -0700
@@ -282,7 +282,10 @@
     i = WifiInformationElement::DeserializeIfPresent(m_htCapability, i);
     i = WifiInformationElement::DeserializeIfPresent(m_vhtCapability, i);
     i = WifiInformationElement::DeserializeIfPresent(m_heCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i);
+    const bool is2_4Ghz = m_rates.IsSupportedRate(
+        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
+                                 // Capabilities IE once the later is implemented
+    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i, is2_4Ghz, m_heCapability);
     return i.GetDistanceFrom(start);
 }
 
@@ -301,7 +304,7 @@
 }
 
 uint64_t
-MgtProbeResponseHeader::GetTimestamp()
+MgtProbeResponseHeader::GetTimestamp() const
 {
     return m_timestamp;
 }
@@ -487,6 +490,24 @@
 }
 
 void
+MgtProbeResponseHeader::SetEhtOperation(const EhtOperation& ehtOperation)
+{
+    m_ehtOperation = ehtOperation;
+}
+
+void
+MgtProbeResponseHeader::SetEhtOperation(EhtOperation&& ehtOperation)
+{
+    m_ehtOperation = std::move(ehtOperation);
+}
+
+const std::optional<EhtOperation>&
+MgtProbeResponseHeader::GetEhtOperation() const
+{
+    return m_ehtOperation;
+}
+
+void
 MgtProbeResponseHeader::SetSsid(const Ssid& ssid)
 {
     m_ssid = ssid;
@@ -709,6 +730,10 @@
     {
         size += m_ehtCapability->GetSerializedSize();
     }
+    if (m_ehtOperation.has_value())
+    {
+        size += m_ehtOperation->GetSerializedSize();
+    }
     return size;
 }
 
@@ -753,6 +778,10 @@
     {
         os << "EHT Capabilities=" << *m_ehtCapability;
     }
+    if (m_ehtOperation.has_value())
+    {
+        os << "EHT Operation=" << *m_ehtOperation;
+    }
 }
 
 void
@@ -824,6 +853,10 @@
     {
         i = m_ehtCapability->Serialize(i);
     }
+    if (m_ehtOperation.has_value())
+    {
+        i = m_ehtOperation->Serialize(i);
+    }
 }
 
 uint32_t
@@ -851,7 +884,11 @@
     i = WifiInformationElement::DeserializeIfPresent(m_heOperation, i);
     i = WifiInformationElement::DeserializeIfPresent(m_muEdcaParameterSet, i);
     i = WifiInformationElement::DeserializeIfPresent(m_multiLinkElement, i, WIFI_MAC_MGT_BEACON);
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i);
+    const bool is2_4Ghz = m_rates.IsSupportedRate(
+        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
+                                 // Capabilities IE once the later is implemented
+    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i, is2_4Ghz, m_heCapability);
+    i = WifiInformationElement::DeserializeIfPresent(m_ehtOperation, i);
 
     return i.GetDistanceFrom(start);
 }
@@ -1199,7 +1236,10 @@
     i = WifiInformationElement::DeserializeIfPresent(m_multiLinkElement,
                                                      i,
                                                      WIFI_MAC_MGT_ASSOCIATION_REQUEST);
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i);
+    const bool is2_4Ghz = m_rates.IsSupportedRate(
+        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
+                                 // Capabilities IE once the later is implemented
+    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i, is2_4Ghz, m_heCapability);
     return i.GetDistanceFrom(start);
 }
 
@@ -1539,7 +1579,10 @@
     i = WifiInformationElement::DeserializeIfPresent(m_multiLinkElement,
                                                      i,
                                                      WIFI_MAC_MGT_REASSOCIATION_REQUEST);
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i);
+    const bool is2_4Ghz = m_rates.IsSupportedRate(
+        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
+                                 // Capabilities IE once the later is implemented
+    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i, is2_4Ghz, m_heCapability);
     return i.GetDistanceFrom(start);
 }
 
@@ -1751,6 +1794,24 @@
 }
 
 void
+MgtAssocResponseHeader::SetEhtOperation(const EhtOperation& ehtOperation)
+{
+    m_ehtOperation = ehtOperation;
+}
+
+void
+MgtAssocResponseHeader::SetEhtOperation(EhtOperation&& ehtOperation)
+{
+    m_ehtOperation = std::move(ehtOperation);
+}
+
+const std::optional<EhtOperation>&
+MgtAssocResponseHeader::GetEhtOperation() const
+{
+    return m_ehtOperation;
+}
+
+void
 MgtAssocResponseHeader::SetMultiLinkElement(const MultiLinkElement& multiLinkElement)
 {
     m_multiLinkElement = multiLinkElement;
@@ -1910,6 +1971,10 @@
     {
         size += m_ehtCapability->GetSerializedSize();
     }
+    if (m_ehtOperation.has_value())
+    {
+        size += m_ehtOperation->GetSerializedSize();
+    }
     return size;
 }
 
@@ -1955,6 +2020,10 @@
     {
         os << "EHT Capabilities=" << *m_ehtCapability;
     }
+    if (m_ehtOperation.has_value())
+    {
+        os << "EHT Operation=" << *m_ehtOperation;
+    }
 }
 
 void
@@ -2017,6 +2086,10 @@
     {
         i = m_ehtCapability->Serialize(i);
     }
+    if (m_ehtOperation.has_value())
+    {
+        i = m_ehtOperation->Serialize(i);
+    }
 }
 
 uint32_t
@@ -2042,7 +2115,11 @@
     i = WifiInformationElement::DeserializeIfPresent(m_multiLinkElement,
                                                      i,
                                                      WIFI_MAC_MGT_ASSOCIATION_RESPONSE);
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i);
+    const bool is2_4Ghz = m_rates.IsSupportedRate(
+        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
+                                 // Capabilities IE once the later is implemented
+    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i, is2_4Ghz, m_heCapability);
+    i = WifiInformationElement::DeserializeIfPresent(m_ehtOperation, i);
     return i.GetDistanceFrom(start);
 }
 
@@ -2111,7 +2188,7 @@
 }
 
 WifiActionHeader::CategoryValue
-WifiActionHeader::GetCategory()
+WifiActionHeader::GetCategory() const
 {
     switch (m_category)
     {
@@ -2144,7 +2221,7 @@
 }
 
 WifiActionHeader::ActionValue
-WifiActionHeader::GetAction()
+WifiActionHeader::GetAction() const
 {
     ActionValue retval;
     retval.selfProtectedAction =
